



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SPOJ 1811 Longest Common Substring (后缀自动机第一题，求两个串的最长公共子串)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SPOJ 1811 Longest Common Substring (后缀自动机第一题，求两个串的最长公共子串)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-24 13:45:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：</p>
<p>给出两个长度小于等于25W的字符串，求它们的最长公共子串。</p>
<p>题目链接：<a href="http://www.spoj.com/problems/LCS/" rel="external nofollow noreferrer">http://www.spoj.com/problems/LCS/</a></p>
<p>算法讨论：</p>
<p>二分+哈希， 后缀数组， 后缀自动机。</p>
<p>随意做。这里面只写一下我对后缀自动机做法的理解。</p>
<p>首先，我们假设两个串分别为A串和B串，我们先对建立出A串的后缀自动机，然后对于B串的每一位，我们进行如下的操作：首先从第1位开始，Parent树上的位置在root，那么对于每一次操作，如果当前结点的字符可以匹配当前B串中所考虑到的字符，那么自然就len ++,然后继续沿着Parent树向下走。如果当前失配，那么根据&ldquo;在Parent树上某一个结点状态的pre指针指向的是可以接收同样后缀的状态结点&rdquo;这条性质，我们在parent树上向上跳。此时，根据parent树原理，其父亲的right集合元素数目变多，字符串长度变短，那么，就可以这么考虑，刚刚在s(临时设个变量表示长度)长度的时候不能完全匹配，所以我们只有减小长度才有再次匹配成功的可能，所以要凭借Parent树来完成（因为Father的Right集合元素数多，所以字符串长度就短），我们沿着Parent树向上跳，这时会出现两种情况，第一，跳到了-1.也就是null状态，这说明B[i]（假设当前正在考虑第i个子串）没有在A串中出现，所以此时把len清0，然后Parent树上位置回root，从新考虑。第二，找到了匹配位置，那么len = st[p].len + 1, p为当前在Parent树上的位置，为什么这样呢？考虑b[i]可以在p这个状态结点成功匹配，由于我们是从Parent上找到这个结点的，所以其前面的字符一定都是匹配的。举个例子，假设我们当前已经成功匹配了2个字符（不是定是B串中的前两个字符，因为是子串），现在考虑b[i],即可能成为成功匹配的第三个字符，如果在p成功匹配，那么由于在Parent树上向上跳了，因为上面提到的性质（Parent树的父亲的状态表示的子串是其儿子的最长后缀），子串长度会变短。假设变短1，所以匹配完后长度变成了2.。。。</p>
<p>Codes：</p>
<div>
<div>
<pre class="prettyprint linenums"> #include &lt;bits/stdc++.h&gt;<br />
 using namespace std;<br />
 const int L =  + ;

 struct State{<br />
   int len, fa;<br />
   int next[];<br />
 }st[L&lt;&lt;];

 struct SuffixAutomaton{<br />
   int sz, last;

   void Init(){<br />
     last = ;<br />
     st[].len = ; st[].fa = -;<br />
     sz ++;<br />
   }<br />
   void Extend(int c){<br />
     int cur = sz ++;<br />
     st[cur].len = st[last].len + ;<br />
        int p;

     for(p = last; p != - &amp;&amp; !st[p].next[c]; p = st[p].fa)<br />
       st[p].next[c] = cur;

     if(p == -) st[cur].fa = ;<br />
     else{<br />
       int q = st[p].next[c];<br />
       if(st[q].len == st[p].len + ) st[cur].fa = q;<br />
       else{<br />
         int cle = sz ++;<br />
         st[cle].len = st[p].len + ;<br />
         st[cle].fa = st[q].fa;<br />
         for(int i = ; i &lt; ; ++ i) st[cle].next[i] = st[q].next[i];<br />
         for(; p != - &amp;&amp; st[p].next[c] == q; p = st[p].fa)<br />
           st[p].next[c] = cle;<br />
         st[q].fa = st[cur].fa = cle;<br />
       }<br />
     }<br />
     last = cur;<br />
   }<br />
 }SAM;

 char str1[L], str2[L];

 int main(){<br />
   scanf("%s%s", str1, str2);

   int len1 = strlen(str1), len2 = strlen(str2);<br />
   int ans = ;

   SAM.Init();<br />
   for(int i = ; i &lt; len1; ++ i)<br />
     SAM.Extend(str1[i] - 'a');

   int p = , len = ;<br />
   for(int i = ; i &lt; len2; ++ i){<br />
     int x = str2[i] - 'a';

     if(st[p].next[x]){<br />
       len ++;<br />
       p = st[p].next[x];<br />
     }<br />
     else{<br />
       while(p != - &amp;&amp; !st[p].next[x]) p = st[p].fa;<br />
       if(p == -){<br />
         len = ; p = ;<br />
       }<br />
       else{<br />
         len = st[p].len + ; p = st[p].next[x];<br />
       }<br />
     }<br />
     ans = max(ans, len);<br />
   }

   printf("%d\n", ans);<br />
   return ;<br />
 }</pre>
</div>
<p>SPOJ 1811</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jxgogq.html">Unity 5&period;3 安装完没有Android&lpar;安卓&rpar;或IOS Module&lpar;模块&rpar;？</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx03xq.html">C&num;实现php的hash&lowbar;hmac函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96gz148.html">09-FZ6R 白色</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prz3zq.html">说说你所熟知的MSSQL中的substring函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mgkep8.html">spring mvc form表单提交乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wddllq.html">PostgreSQL Performance Monitoring Tools</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okl4gx9.html">QGraphicsEffect介绍（十分漂亮）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y65v3q.html">九度OJ 1511 从尾到头打印链表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpkzjq.html">docker build lnmp&lpar;未完成。。。&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxng73d8.html">Android开发系列----sdk下载 环境准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok0d519.html">Android 批量上传sd卡图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x0rdz9.html">NGUI使用教程&lpar;1&rpar; 安装NGUI插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkogvv8.html">flex chrome浏览器调试flex程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz260g8.html">linux新学篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwvpk9.html">JavaScript 父子页面相互调用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvr148.html">【Intellij Idea】设置JDK</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj14yz9.html">承接AR摄像头识别外包 AR图像识别 AR识别图像 AR识别应用外包</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25w22oq.html">Java&period;net&period;SocketException&colon; Unrecognized Windows Sockets error&colon; 0&colon; JVM&lowbar;Bind异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvjz2r8.html">浅谈https和http2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ol50e8.html">Django REST Framework API Guide 04</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gmo5j79.html">HTML解析利器 - HtmlAgilityPack</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn7yld8.html">Keil C减小代码编译量大小的方法&lpar;gai&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn1ye2q.html">Tree 使用方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z1yg09.html">FileUtils类应该有哪些内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd34w38.html">Makefile的几个赋值运算符（转：笔记）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn1r00q.html">添加多盟SDK 库函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ovzxv9.html">逃离迷宫（HDU 1728 BFS）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wp6wxq.html">Android平台之不预览获取照相机预览数据帧及精确时间截</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wp6vlq.html">JavaIO学习总结一</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okmwgx9.html">gridview两列数据的互换</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
